#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>

/*
Main.cpp file by Toby Korn (tkorn@snl.com)
This file is used to create a blat.DLL with one 
exported function Send wich takes the command line for Blat.

*/

int main( int argc,     
          char *argv[], 
          char **envp );

BOOL    WINAPI   DllMain (HANDLE hInst, 
                            ULONG ul_reason_for_call,
                            LPVOID lpReserved)
{
	return TRUE;
}

int iSeparateWords (char *sCmd)
{
	char *cPtr, *cPTemp, *cPAfterQuote;
	int iCount;
	int iQuote; 

	iCount = 0;
	iQuote = 0;

	// Skip spaces
	for (cPtr = sCmd; *cPtr == ' '; cPtr++);
	// Count words until we reach Null termination character
	while (*cPtr != '\0')
	{
		for (; *cPtr != ' ' && *cPtr != '\0' && *cPtr != '"'; cPtr++);
		if (*cPtr == ' ')
			{
			*cPtr = '\0';
			iCount++;
			cPtr++;
			for (; *cPtr == ' '; cPtr++);
			}
		else if (*cPtr == '"') 
		{
			// remember where I am and move all characters to the right to get rid of this quote
			for (cPTemp = cPtr + 1; *cPTemp; cPTemp++)
				*(cPTemp - 1) = *cPTemp;
			*(cPTemp -1) = '\0';
			// go back to where I was and look for the closing quote
			for (cPTemp = cPtr; *cPTemp && *cPTemp != '"'; cPTemp++);
			cPAfterQuote = cPTemp; 
			// Now move characters to right again.
			for (++cPTemp; *cPTemp; cPTemp++)
				*(cPTemp - 1) = *cPTemp;
			*(cPTemp - 1) = '\0';
			cPtr = cPAfterQuote - 1;		    
		}
	}
	cPtr++;
	*cPtr = '\0';
	return ++iCount;
}

int APIENTRY Send (LPCSTR sCmd)
{
	char **argv;
	char *sIn; 
	char *sCurrent;
	int iCount;
	int iResult, i;
	
	iResult = 0;
	sIn = (char *) malloc (strlen ((char *)sCmd) + 2);
	if (sIn)
		{
		strcpy (sIn, (char *) sCmd);
		iCount = iSeparateWords (sIn);
		argv = (char **) malloc (((1 + iCount) * sizeof (char *)));
		if (argv)
			{
			argv[0] = NULL;
			sCurrent = sIn;
			for (i = 1; i <= iCount && *sCurrent != '\0'; i++)
			{
				argv[i] = (char *) malloc ((strlen (sCurrent) + 1) * sizeof (char));
				if (argv[i]) 
					strcpy (argv[i], sCurrent);
				while (*sCurrent != '\0') 
					sCurrent++;
				sCurrent++;
			}
		iResult = main (iCount+1, argv, NULL);
		for (i = 0; i <= iCount; i++)
			if (argv[i])
				free (argv[i]);
		free (argv);
		}
	}
	else
		iResult = -1;
	if (sIn)
		free (sIn);
	return iResult;
}